if(typeof(b2rPopup_defined)=='undefined'){
b2rPopup_defined=true;
	function Event_pointerX(aEvent){
		var event=aEvent||window.event;
	      var docElement = document.documentElement,
	          body = document.body || { scrollLeft: 0, scrollTop: 0 };
		return(event.pageX || (event.clientX +
	          (docElement.scrollLeft || body.scrollLeft) -
	          (docElement.clientLeft || 0)));
	}

	function Event_pointerY(aEvent){
		var event=aEvent||window.event;
	      var docElement = document.documentElement,
	          body = document.body || { scrollLeft: 0, scrollTop: 0 };
		return(event.pageY || (event.clientY +
	          (docElement.scrollTop || body.scrollTop) -
	          (docElement.clientTop || 0)));
	}


	function Event_element(aEvent){
		var event=aEvent||window.event;
	  var node          = event.target||event.srcElement,
	      type          = event.type,
	      currentTarget = event.currentTarget;

	  if (currentTarget && currentTarget.tagName) {
	    if (type === 'load' || type === 'error' ||
	      (type === 'click' && currentTarget.tagName.toLowerCase() === 'input'
	        && currentTarget.type === 'radio'))
	          node = currentTarget;
	  }
	  if (node.nodeType == 3){
	  	node = node.parentNode;
	  }
	  if(!node.text){
	  	node.text=node.innerText;
	  }
	  return(node);
	};

	function Event_relatedTarget(aEvent){
		var event=aEvent||window.event;
	  var element;
	  switch(event.type) {
	    case 'mouseover': element = event.fromElement; break;
	    case 'mouseout':  element = event.toElement;   break;
	    default: return null;
	  }
	  return(element);
	}





	function $$(tag_class){
		var res=[];
		var tag=""+tag_class.match(/^[^\.]+/);
		var cn=""+tag_class.match(/[^\.]+$/);
		
		var nodes=document.getElementsByTagName(tag);
		for(var i=0,l=nodes.length;i<l;i++){
			if(nodes[i].className.indexOf(cn)!=-1){
				res.push(nodes[i]);
			}
		}
		return(res);
	}


function setTimeout2(func,delay){
	var args=[];
	for(var i=2;i<arguments.length;i++){
		args.push(arguments[i]);
	}
	
	return(window.setTimeout(function(){
		func.apply(window,args);
	},delay));
	
}

	var b2rPopup = {
		POPUP_DELAY: 200,
		startup: function(){
			setTimeout(function(){
				b2rPopup.resPopup.init();
				b2rPopup.imagePopup.init();
				b2rPopup.idPopup.init();
				b2rPopup.videoPopup.init();
			}, 100);
		},
		mouseOut: function(aEvent){
			var targetNode = Event_element(aEvent);
			if(targetNode._popupTimeout){
				clearTimeout(targetNode._popupTimeout);
				targetNode._popupTimeout = null;
			}
		},
		showPopup: function(aEvent, aContentNode, aClassName){
			var targetNode = Event_element(aEvent);
			if(targetNode._popupTimeout){
				clearTimeout(targetNode._popupTimeout);
			}
			
			targetNode._popupTimeout = setTimeout2(b2rPopup._showPopupDelay, b2rPopup.POPUP_DELAY,
					Event_pointerX(aEvent), Event_pointerY(aEvent), aContentNode, aClassName);
		},
		_showPopupDelay: function(aPageX, aPageY, aContentNode, aClassName){
			var popup = document.createElement("div");
			popup.className = aClassName || "popup";
			popup.onmouseout = function(aEvent){
				var px=Event_pointerX(aEvent),py=Event_pointerY(aEvent);
			//	document.title=[px,py,this.offsetLeft,this.offsetTop,this.offsetWidth,this.offsetHeight];
				if( px<= this.offsetLeft+3 ||
						py <= this.offsetTop+3 ||
						px >= this.offsetLeft + this.offsetWidth-3 ||
						py >= this.offsetTop + this.offsetHeight-3
					){
					this.onmouseout = null;
					document.body.removeChild(this);
				}
			};
			popup.appendChild(aContentNode);
			document.body.appendChild(popup);
			if(popup.clientWidth > window.innerWidth - 40){
				popup.style.width = (window.innerWidth - 40) + "px";
			}
			if(popup.clientHeight > window.innerHeight - 20){
				popup.style.height = (window.innerHeight - 20) + "px";
			}
			var winPageRight = window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth;
			var ih=window.innerHeight||document.documentElement.clientHeight||document.body.clientHeight ;
			var sy=window.scrollY||document.body.scrollTop||document.documentElement.scrollTop;
			var winPageBottom = ih + sy;
			var x = winPageRight - (popup.clientWidth + aPageX);
			var y = winPageBottom - (popup.clientHeight + aPageY);
			if(x > 0){
				popup.style.left = (aPageX - 10) + "px";
			}else{
				popup.style.left = "auto";
				popup.style.right = "10px";
			}
			if(y > 0){
				popup.style.top = (aPageY - 10) + "px";
			}else{
				popup.style.top = (winPageBottom - popup.clientHeight - 10) + "px";
			}
		}

	};

	b2rPopup.resPopup = {
		init: function(){
			var nodes=$$('a.resPointer');
			for(var i=0,l=nodes.length;i<l;i++){
				nodes[i].setAttribute("onmouseover", "b2rPopup.resPopup.mouseOver(event)");
				nodes[i].setAttribute("onmouseout", "b2rPopup.mouseOut(event)");
			}
		},
		mouseOver: function(aEvent){
			var targetNode = Event_element(aEvent);
			var relatedNode = Event_relatedTarget(aEvent);
			if(relatedNode && (relatedNode.className=="popup" ||
					relatedNode.parentNode.className=="popup") &&
						!targetNode._popupTimeout){ return; }
			var startRes = 0;
			var endRes = 0;
			if(targetNode.text.match(/>>?(\d{1,3})-(\d{1,3})/)){
				startRes = parseInt(RegExp.$1);
				endRes = parseInt(RegExp.$2);
			}else if(targetNode.text.match(/>>?(\d{1,3})/)){
				startRes = parseInt(RegExp.$1);
			}
			var content = b2rPopup.resPopup.createContent(startRes, endRes);
			if(content){
				b2rPopup.showPopup(aEvent, content);
			}
		},
		createContent: function(aStart, aEnd){
			var content = document.createDocumentFragment();
			var resNode = document.getElementById("res" + aStart);
			if(!resNode) return null;
			if(aStart < aEnd){ // |bvAbv
				if(aStart < 1) aStart = 1;
				if(aEnd > 1000) aEnd = 1000;
				var POPUP_LIMIT = 20;

				if((aEnd - aStart) > POPUP_LIMIT) aStart = aEnd - POPUP_LIMIT;

				for(var i = aStart; i<=aEnd; i++){
					resNode = document.getElementById("res" + i);
					if(!resNode) break;
					content.appendChild(b2rPopup.resPopup.getCloneNode(resNode));
				}
			}else{ // ʏ|bvAbv
				content.appendChild(b2rPopup.resPopup.getCloneNode(resNode));
			}
			if(!content.firstChild) return null;
			return content;
		},
		getCloneNode: function(aNode){
			aNode = aNode.cloneNode(true);
			if(aNode.id) aNode.id = "";
			var elements = aNode.getElementsByTagName("*");
			for(var i=0; i<elements.length; i++){
				if(elements[i].id) elements[i].id = "";
			}
			return aNode;
		}
	};


	b2rPopup.imagePopup = {

		init: function(){
			var nodes=$$("a.outLink");
			for(var i=0,l=nodes.length;i<l;i++){
				if(!nodes[i].href.match(/\.jpg$|png$|gif$/i)) continue;
				nodes[i].setAttribute("onmouseover", "b2rPopup.imagePopup.mouseOver(event)");
				nodes[i].setAttribute("onmouseout", "b2rPopup.mouseOut(event)");
			}
		},

		mouseOver: function(aEvent){
			var targetNode = Event_element(aEvent);
			var relatedNode = Event_relatedTarget(aEvent);
			if(relatedNode && (relatedNode.className=="imagePopup" ||
					relatedNode.parentNode.className=="imagePopup") &&
						!targetNode._popupTimeout){ return; }

			var image = document.createElement("img");
			image.style.width = "120px";
			image.style.height= "auto";
			image.style.borderStyle = "none";
			image.src = targetNode.href;
			image.onclick = function(aEvent){
			var targetNode = Event_element(aEvent);
				targetNode.style.width = (targetNode.style.width == "") ? "120px" : "";
			}
			b2rPopup.showPopup(aEvent, image, "imagePopup");
		}

	};


	b2rPopup.idPopup = {

		init: function(){
			var nodes=$$("span.resID").concat($$("span.resMesID"));
			for(var i=0,l=nodes.length;i<l;i++){
				nodes[i].setAttribute("onmouseover", "b2rPopup.idPopup.mouseOver(event)");
				nodes[i].setAttribute("onmouseout", "b2rPopup.mouseOut(event)");
			}
		},

		mouseOver: function(aEvent){
			var targetNode = Event_element(aEvent);
			var resID = "";
			if(targetNode.className.substring(0, 3) == "id_"){
				resID = targetNode.className.substring(3);
			}else{
				resID = targetNode.className.substring(6);
			}
			if(resID == "") return;
			if(resID.substring(0, 3) == "???") return;
			
			var currentResNumber = parseInt(targetNode.parentNode.parentNode.parentNode.id.substring(3));
			var nodes=$$("span.id_"+resID);
			var resNumbers = new Array();
			for(var i=0,l=nodes.length;i<l;i++){
				var node=nodes[i].parentNode.parentNode.parentNode;
				var nodeResNumber=parseInt(node.id.substring(3));
				if(nodeResNumber!=currentResNumber){
					resNumbers.push(nodeResNumber);
				}
			}
			if(resNumbers.length == 0) return;

			var start = 0;
			if(resNumbers.length > 10) start = resNumbers.length - 10;

			var content = document.createDocumentFragment();
			if(start > 0){
				var p = document.createElement("p");
				p.appendChild(document.createTextNode(start +"ȗ"));
				content.appendChild(p);
			}
			for(i=start; i<resNumbers.length; i++){
				var resNode = document.getElementById("res" + resNumbers[i]);
				if(!resNode) break;
				content.appendChild(b2rPopup.idPopup.getCloneNode(resNode));
			}
			if(!content.firstChild) return;

			b2rPopup.showPopup(aEvent, content);
		},


		getCloneNode: function(aNode){
			aNode = aNode.cloneNode(true);
			if(aNode.id) aNode.id = "";
			var elements = aNode.getElementsByTagName("*");
			for(var i=0; i<elements.length; i++){
				if(elements[i].id) elements[i].id = "";
				if(elements[i].className.substring(0, 3) == "id_") elements[i].className = "";
			}
			return aNode;
		}

	};


	b2rPopup.videoPopup = {

		init: function(){
			var nodes=$$("a.outLink");
			for(var i=0,l=nodes.length;i<l;i++){
				if(!nodes[i].href.match(/\.youtube.com\/watch/i)) continue;
				nodes[i].setAttribute("onmouseover", "b2rPopup.videoPopup.mouseOver(event)");
				nodes[i].setAttribute("onmouseout", "b2rPopup.mouseOut(event)");
			}
		},

		mouseOver: function(aEvent){
			var targetNode = Event_element(aEvent);
			var relatedNode = Event_relatedTarget(aEvent);
			if(relatedNode && relatedNode.className == "imagePopup") return;
			var url = targetNode.href;
			var content;
			if(url.indexOf(".youtube.com")!=-1 && url.match(/v=([^\&]+)/)){
				content = b2rPopup.videoPopup.createYoutubeContent(RegExp.$1);
			}
			if(content){
				b2rPopup.showPopup(aEvent, content, "imagePopup");
			}
		},


		createYoutubeContent: function(aVideoID){
			var videoURL = "http://www.youtube.com/v/" + aVideoID
			var videoObject = document.createElement("object");
			videoObject.setAttribute("data", videoURL);
			videoObject.setAttribute("type", "application/x-shockwave-flash");
			videoObject.setAttribute("width", "320");
			videoObject.setAttribute("height", "260");
			
			var videoEmbed=document.createElement("embed");
			videoEmbed.setAttribute("src",videoURL);
			videoEmbed.setAttribute("pluginspage","http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash");
			videoEmbed.setAttribute("width", "320");
			videoEmbed.setAttribute("height", "260");
			
			videoObject.appendChild(videoEmbed);
			return videoObject;
		}

	};
}




